#include <stdio.h>
#include <pthread.h>

pthread_t       thr1,  thr2;
pthread_mutex_t res_A, res_B;

void *thread1 (void *args) {
  pthread_mutex_lock (&res_A);    printf ("thread1: locked A\n");
  pthread_mutex_lock (&res_B);    printf ("thread1: locked B\n");
  
  printf ("thread1: critical!\n"); sleep (1);
  
  pthread_mutex_unlock (&res_A);  printf ("thread1: unlocked A\n");
  pthread_mutex_unlock (&res_B);  printf ("thread1: unlocked B\n");
}

void *thread2 (void *args) {
  pthread_mutex_lock (&res_B);    printf ("thread2: locked B\n");
  pthread_mutex_lock (&res_A);    printf ("thread2: locked A\n");
  
  printf ("thread2: critical!\n"); sleep (1);
  
  pthread_mutex_unlock (&res_A);  printf ("thread2: unlocked A\n");
  pthread_mutex_unlock (&res_B);  printf ("thread2: unlocked B\n");
}

// Folgende Zeile auskommentieren, um Cheating zu aktivieren
// #define CHEATING

int main () {
  pthread_mutex_init(&res_A, NULL);
  pthread_mutex_init(&res_B, NULL);
       
  // Threads erzeugen
  pthread_create (&thr1, NULL, thread1, NULL);
  pthread_create (&thr2, NULL, thread2, NULL);

  #ifdef CHEATING
    // Cheating
    sleep (5);
    printf ("main:   Nach 5 Sekunden: Cheat (unlocking A)...\n");
    pthread_mutex_unlock (&res_A);    // illegal!
  #endif

  // Threads einsammeln
  pthread_join (thr1, NULL);
  pthread_join (thr2, NULL);

  printf ("Fertig\n");
}

